Bug 10866 - several problems with bootable flag
: several problems with bootable flag
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/alterator-install2)
: unstable
: all Linux
: P2 blocker
Assigned To:
:
:
:
:
: 17612 17613
  Show dependency tree
 
Reported: 2007-02-19 16:18 by
Modified: 2008-10-18 17:05 (History)


Attachments
74b1a3c79056b624af20c512e8ade0e923827bee (5.24 KB, patch)
2008-10-18 16:36, Michael Shigorin
no flags Details | Diff


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2007-02-19 16:19:28
У нынешнего alterator-vm есть несколько серьёзных проблем с bootable flag.

1. bootable flag не отображается в списке разделов; невозможно выяснить, куда
установлен bootable flag.  Как вариант решения, можно завести ещё один столбец
и
показывать этот флаг в нём.
2. Невозможно установить bootable flag на готовый раздел; чтобы установить
bootable flag на готовый раздел, приходится удалять и создавать раздел, что
может привести к разрушению файловой системы на нём.  Как вариант решения,
можно
разрешить менять значение этого влага для готовых разделов.
3. Позволяется поставить bootable flag сразу на несколько разделов одного
диска.
 Некоторые bios'ы не поддерживают загрузку с таких дисков.  Как вариант
решения,
можно в сочетании с визуализацией этого флага (п.1) выдавать предупреждение,
аналогичное тому, которое выдаётся сейчас при отстутствии флага вообще.
------- Comment #1 From 2007-02-19 16:28:47 -------
п.2: невозможное -- невозможно. ограничение evms.
------- Comment #2 From 2007-02-20 13:21:59 -------
А получается ли по тем граблям, которые выгребли с libevms, озадачить апстрим? 
Или бессмысленно?
------- Comment #3 From 2007-02-20 13:43:22 -------
<vsu> lioka: а bootable надо - как минимум для того, чтобы нормальным образом
ставить загрузчик не в mbr
<raorn> а lilo не умеет проставлять bootable сам?
<raorn> было чё-то в man'е
<lioka> vsu: оки. а про два и более bootable ?
<vsu> ага,        -A master-device [ N ]
<vsu> lioka: не надо так делать
<vsu> lioka: скорее всего, загрузится первый из них, но при особо умном биосе
до
загрузки может и не дойти
<lioka> vsu: я собссно и не ставлю второй bootable
<vsu> lioka: биосы, не желающие грузиться при отсутствии активного раздела,
тоже
есть в большом количестве
<raorn> может в установку бутлоадера это вынести?
<lioka> vsu: вопрос в том, принуждать ли узера к правильному поведению с т.з.
тупых биосов
<vsu> lioka: ну мелкософтовский fdisk принуждает :)
<lioka> vsu: да не вопрос. потом не плюйся, когда я этот же аргумент тебе и
верну
<vsu> lioka: ну тебе же предлагают предупреждение по этому поводу
<lioka> vsu: на самом деле предлагают тебе согласиться с тем, что тебе придётся
лицезреть все эти попапчики и крестики. мне-то по барабану, что кодить
<vsu> lioka: короче, мне нужно, чтобы при установке на диск, на котором уже
есть
один раздел, помеченный как bootable, можно было переставить этот флаг с того
раздела на новый
<gvy> vsu, возможно, поможет сперва сбрасывать _все_ bootable?
* raorn ещё раз предлагает вынести это в установку бутлоадера
<lioka> vsu: переставить не получится иначе как пересозданием разделов
<vsu> lioka: значит, так и придётся переключаться в этом месте в консоль и
запускать там fdisk
<vsu> lioka: кнопочка reload там будет?
<lioka> vsu: в этом -- это в каком ?
<vsu> lioka: в разбивке разделов - чтобы прочитать то, что наделано fdisk-ом
<gvy> lioka, а если дейсно унести к бутлодёру?
<lioka> vsu: посередине evms тоже мало пользы -- пока не закоммитить evms'ные
изменения и не перечитать разделы, fdisk будет мазать
<lioka> gvy: резонно, но боюсь, не встречу взаимности
встретишь?
<vsu> lioka: ну если кто-то полезет с незакоммиченными изменениями - ССЗБ
<lioka> vsu: лекарство несоразмерно болезни
<vsu> lioka: а вот при отсутствии изменений нужен способ обновить состояние в
соответствии с текущим состоянием дисков
<vsu> lioka: сойдёт даже кнопка Back, если она на этом шаге работает
<lioka> не работает
<vsu> lioka: тогда приделывай reload
<vsu> lioka: иначе вместо него опять придётся использовать reboot :-\
------- Comment #4 From 2007-02-20 14:49:52 -------
Может правда перенести функционал выставление bootable флага на bootloader ?
Мне кажется это правльным. Я не гордый и сумею воспользоваться sfdisk'ом.
Кстати, в инсталяторе на стадии /vm нет fdisk'a.
------- Comment #5 From 2007-02-20 15:42:11 -------
legion: если у тебя есть идеи, как это 1) сделать 2) сделать правильно --
буду только рад.
------- Comment #6 From 2007-02-20 16:11:19 -------
(In reply to comment #5)
> legion: если у тебя есть идеи, как это 1) сделать 2) сделать правильно --
> буду только рад.

Я могу реализовать только следующий алгоритм: если пользователь выбрал установку
загрузчика на volume и этот volume совпадает с разделом (fdisk -l), то выставить
на него флаг bootable (конечно убрав старый). Иначе я ставлюсь в mbr одного из
дисков.
------- Comment #7 From 2007-03-08 19:33:23 -------
Стало быть, перевешиваю на alterator-install2, чтобы закрыть.
------- Comment #8 From 2007-03-08 19:34:24 -------
Fixed in 74b1a3c79056b624af20c512e8ade0e923827bee.
------- Comment #9 From 2007-11-10 18:14:18 -------
ack
------- Comment #10 From 2008-10-18 16:36:56 -------
Created an attachment (id=3007) [details]
74b1a3c79056b624af20c512e8ade0e923827bee

Поскольку добраться до этого коммита может быть уже нетривиально
(alterator-install2 в obsolete), прилагаю для истории.